#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef double lf;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

#define TRACE(x) cerr << #x << ' ' << x << endl
#define FOR(i, a, b) for (int i = (a); i < (b); i++)
#define REP(i, n) FOR(i, 0, n)
#define _ << ' ' <<

#define fi first
#define sec second
#define se second
#define mp make_pair
#define pb push_back

const int off = 1 << 18;

struct tournament {
  ll t[2 * off], p[2 * off];;
 
  void prop(int x, int lo, int hi) {
    if(p[x]) {
      t[x] += (ll) (hi - lo) * p[x];
      if(x < off) {
         p[x*2]+=p[x];
         p[x*2+1]+=p[x];
       }
       p[x] = 0;
    }
  }

  ll get(int x, int lo, int hi, int a, int b) {
    if(lo >= b || hi <= a) {
      return 0;
    }
    prop(x, lo, hi);
    if(lo >= a && hi <= b) {
      return t[x];
    }
    int mi = (lo + hi) >> 1;
    return get(x*2, lo, mi, a, b) + get(x*2+1, mi, hi, a, b);
  }
  void upd(int x, int lo, int hi, int a, int b, int v) {
    if(lo >= a && hi <= b) {
      p[x] += v;
      prop(x, lo, hi);
      return;
    }
    prop(x, lo, hi);
    if(lo >= b || hi <= a) {
      return;
    }
    int mi = (lo + hi) >> 1;
    upd(x*2, lo, mi, a, b, v);
    upd(x*2+1, mi, hi, a, b, v);
    t[x] = t[x*2] + t[x*2+1];
  }
} T;

typedef pair<int, pii> par;

int a[off];
const int mod = 1e9 + 7;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);

  int n; cin >> n;
  REP(i, n) cin >> a[i];
  
  vector<par> inter;
  stack<pii> maxi;
  maxi.push({-1, 1e9 + 5});
  ll sol = 0;
  REP(i, n) {
    inter.pb(par(a[i], pii(i, i)));
    vector<par> ninter;
    REP(j, (int) inter.size()) {
      inter[j].fi = __gcd(a[i], inter[j].fi);
    }
    par tmp = inter[0];
    FOR(j, 1, (int) inter.size()) {
      if(tmp.fi  == inter[j].fi) {
        tmp.se.se = inter[j].se.se;
      }
      else {
        ninter.pb(tmp);
        tmp = inter[j];
      }
    }
    ninter.pb(tmp);
    
    T.upd(1, 0, off, i, i + 1, a[i]);
    int od = i - 1;
    while(maxi.top().se < a[i]) {
      int pos = maxi.top().fi;
      T.upd(1, 0, off, pos + 1, od + 1, a[i] - maxi.top().se);
      od = pos;
      maxi.pop();
    }

    maxi.push({od, a[i]});
    inter = ninter;
    for(auto p: inter) {
      sol += (ll) (T.get(1, 0, off, p.se.fi, p.se.se + 1) % mod) * p.fi;
      sol %= mod;
    }
  }

  cout << sol << endl;

  return 0;
}

